Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  abstract class SpecializeTypes extends SubComponent with InfoTransform with TypingTransformers

  Specialize code on types.

  Specialize code on types.

  Make sure you've read the thesis:

  Iulian Dragos: Compiling Scala for Performance (chapter 4)

  There are some things worth noting, (possibly) not mentioned there: 0) Make sure you understand the meaning of various `SpecializedInfo` descriptors defined below.

  1) Specializing traits by introducing bridges in specialized methods of the specialized trait may introduce problems during mixin composition. Concretely, it may cause cyclic calls and result in a stack overflow. See ticket #4351. This was solved by introducing an `Abstract` specialized info descriptor. Instead of generating a bridge in the trait, an abstract method is generated.

  2) Specialized private members sometimes have to be switched to protected. In some cases, even this is not enough. Example:

      class A[@specialized T](protected val d: T) {
        def foo(that: A[T]) = that.d
      }

  Specialization will generate a specialized class and a specialized method:

      class A$mcI$sp(protected val d: Int) extends A[Int] {
        def foo(that: A[Int]) = foo$mcI$sp(that)
        def foo(that: A[Int]) = that.d
      }

  Above, `A$mcI$sp` cannot access `d`, so the method cannot be typechecked.

  Definition Classes
    transform
- Abstract
- Duplicator
- Forward
- Implementation
- ImplementationAdapter
- NormalizedMember
- Overload
- Phase
- SpecialOverload
- SpecialOverride
- SpecialSuperAccessor
- SpecializationDuplicator
- SpecializationPhase
- SpecializationTransformer
- SpecializedAccessor
- SpecializedInfo
- SpecializedInnerClass
- SpecializedSuperConstructorCallArgument
- StdPhase
- TypeEnv
- TypingTransformer
- UnifyError

c

scala.tools.nsc.transform.SpecializeTypes

# Forward 

###

#### case class Forward(t: Global.Symbol) extends SpecializedInfo with Product with Serializable

Symbol is a method that should be forwarded to 't'

Source
  SpecializeTypes.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, SpecializedInfo, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Forward
2. Serializable
3. Serializable
4. Product
5. Equals
6. SpecializedInfo
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Forward(t: Global.Symbol)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Forward to any2stringadd[Forward] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Forward, B)
   Implicit
     This member is added by an implicit conversion from Forward to ArrowAssoc[Forward] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def degenerate: Boolean

   A degenerated method has @specialized type parameters that appear only in type bounds of other @specialized type parameters (and not in its result type).

   A degenerated method has @specialized type parameters that appear only in type bounds of other @specialized type parameters (and not in its result type).

   Definition Classes
     SpecializedInfo
9.  def ensuring(cond: (Forward) ⇒ Boolean, msg: ⇒ Any): Forward
   Implicit
     This member is added by an implicit conversion from Forward to Ensuring[Forward] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (Forward) ⇒ Boolean): Forward
    Implicit
      This member is added by an implicit conversion from Forward to Ensuring[Forward] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: ⇒ Any): Forward
    Implicit
      This member is added by an implicit conversion from Forward to Ensuring[Forward] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): Forward
    Implicit
      This member is added by an implicit conversion from Forward to Ensuring[Forward] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Forward to StringFormat[Forward] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
17.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
18.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  final def notify(): Unit
    Definition Classes
      AnyRef
20.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
21.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
22.  val t: Global.Symbol
23.  def target: Global.Symbol
    Definition Classes
      Forward → SpecializedInfo
24.  def typeBoundsIn(env: TypeEnv): Boolean

    Are type bounds of @specialized type parameters of 'target' now in 'env'?

    Are type bounds of @specialized type parameters of 'target' now in 'env'?

    Definition Classes
      SpecializedInfo
25.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
26.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
27.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
28.  def →[B](y: B): (Forward, B)
    Implicit
      This member is added by an implicit conversion from Forward to ArrowAssoc[Forward] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from SpecializedInfo

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Forward to any2stringadd[Forward]

### Inherited by implicit conversion StringFormat from Forward to StringFormat[Forward]

### Inherited by implicit conversion Ensuring from Forward to Ensuring[Forward]

### Inherited by implicit conversion ArrowAssoc from Forward to ArrowAssoc[Forward]

### Ungrouped